<?php
/* * **********************************************
 * Copyright (C) 2016-2019	Sylvain Legrand - <contact@infras.fr>	InfraS - <https://www.infras.fr>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * ********************************************** */

/* * **********************************************
 * 	\file		../infrassearch/script/interface.php
 * 	\ingroup	InfraS
 * 	\brief		Page to interface the module InfraSSearch
 * ********************************************** */

// Dolibarr environment *************************
//$res = 0;
//if (!$res && file_exists("../../main.inc.php")) $res = @include("../../main.inc.php"); // For root directory
//if (!$res && file_exists("../../../main.inc.php"))
//        $res = @include("../../../main.inc.php"); // For "custom" directory
//
// Libraries ************************************
$libs   = array();
$libs[] = DOL_DOCUMENT_ROOT.'/categories/class/categorie.class.php';
$libs[] = DOL_DOCUMENT_ROOT.'/product/class/product.class.php';
$libs[] = DOL_DOCUMENT_ROOT.'/societe/class/societe.class.php';
$libs[] = DOL_DOCUMENT_ROOT.'/societe/class/address.class.php';
$libs[] = DOL_DOCUMENT_ROOT.'/projet/class/project.class.php';
$libs[] = DOL_DOCUMENT_ROOT.'/projet/class/task.class.php';
$libs[] = DOL_DOCUMENT_ROOT.'/comm/action/class/actioncomm.class.php';
$libs[] = DOL_DOCUMENT_ROOT.'/comm/propal/class/propal.class.php';
$libs[] = DOL_DOCUMENT_ROOT.'/commande/class/commande.class.php';
$libs[] = DOL_DOCUMENT_ROOT.'/compta/facture/class/facture.class.php';
$libs[] = DOL_DOCUMENT_ROOT.'/contrat/class/contrat.class.php';
$libs[] = DOL_DOCUMENT_ROOT.'/fichinter/class/fichinter.class.php';
$libs[] = DOL_DOCUMENT_ROOT.'/expedition/class/expedition.class.php';
$libs[] = DOL_DOCUMENT_ROOT.'/supplier_proposal/class/supplier_proposal.class.php';
$libs[] = DOL_DOCUMENT_ROOT.'/fourn/class/fournisseur.commande.class.php';
$libs[] = DOL_DOCUMENT_ROOT.'/fourn/class/fournisseur.facture.class.php';
$libs[] = DOL_DOCUMENT_ROOT.'/ticket/class/ticket.class.php';
foreach ($libs as $lib) {
    if (file_exists($lib)) require_once $lib;
}
$classPaths = array('/equipement/class/equipement.class.php',
    '/ndfp/class/ndfp.class.php',
    '/contacttracking/class/contacttracking.class.php',
    '/domain/class/domain.class.php',
    '/hosting/class/host.class.php',
     '/ticketsup/class/ticket.class.php',
    '/ticketsup/class/ticketsup.class.php',
    '/ticketsup/class/ticketsuplogs.class.php',
    '/abricot/inc.core.php',
    '/propalehistory/class/propaleHist.class.php',
    '/rmindr/class/rmindr.class.php',
    '/factory/class/factory.class.php',

    '/qualityreport/class/qualityreport.class.php'
);
foreach ($classPaths as $classPath) {
    $testClass = dol_buildpath($classPath, 0, 1);
    if ($testClass) require_once $testClass;
} // foreach ($classPaths as $classPath)
$langs->load('infrassearch@infrassearch');
$langs->load('orders');

function dol_search($TObjectTypeValid, $keyword, $asArray = false)
{
    global $db, $conf, $langs;

    $show_find_field = isset($conf->global->INFRASSEARCH_SHOW_FIND_FIELD) ? $conf->global->INFRASSEARCH_SHOW_FIND_FIELD : '';
    $TResult         = array();
    $nbRows          = isset($conf->global->INFRASSEARCH_NB_ROWS) ? $conf->global->INFRASSEARCH_NB_ROWS : 3;
    $sql_where_p     = false;
    $sql_where_sp    = false;
    switch ($TObjectTypeValid) {
        case 'categorie':
            $tables         = array(MAIN_DB_PREFIX.'categorie', MAIN_DB_PREFIX.'categories_extrafields');
            $objname        = 'Categorie';
            $complete_label = 'description';
            $sql_join       = 'LEFT JOIN '.MAIN_DB_PREFIX.'categories_extrafields ON ('.MAIN_DB_PREFIX.'categorie.rowid = '.MAIN_DB_PREFIX.'categories_extrafields.fk_object)';
            $id_field       = MAIN_DB_PREFIX.'categorie.rowid';
            break;
        case 'product':
            $tables         = array(MAIN_DB_PREFIX.'product', MAIN_DB_PREFIX.'product_extrafields');
            $objname        = 'Product';
            $customtabelem  = array('element' => 'product', 'maintabl' => 'product');
            $complete_label = 'label';
            $sql_join       = 'LEFT JOIN '.MAIN_DB_PREFIX.'product_extrafields ON ('.MAIN_DB_PREFIX.'product.rowid = '.MAIN_DB_PREFIX.'product_extrafields.fk_object)';
            $id_field       = MAIN_DB_PREFIX.'product.rowid';
            break;
        case 'thirdparty':
            $tables         = array(MAIN_DB_PREFIX.'societe', MAIN_DB_PREFIX.'societe_extrafields', MAIN_DB_PREFIX.'societe_address',
                MAIN_DB_PREFIX.'socpeople');
            $objname        = 'Societe';
            $customtabelem  = array('element' => 'thirdparty', 'maintabl' => 'societe');
            $complete_label = '';
            $sql_join       = 'LEFT JOIN '.MAIN_DB_PREFIX.'societe_extrafields ON ('.MAIN_DB_PREFIX.'societe.rowid = '.MAIN_DB_PREFIX.'societe_extrafields.fk_object)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'societe_address ON ('.MAIN_DB_PREFIX.'societe.rowid = '.MAIN_DB_PREFIX.'societe_address.fk_soc)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'socpeople ON ('.MAIN_DB_PREFIX.'societe.rowid = '.MAIN_DB_PREFIX.'socpeople.fk_soc)';
            $sql_where_sp   = true;
            $id_field       = MAIN_DB_PREFIX.'societe.rowid';
            break;
        case 'contact':
            $tables         = array(MAIN_DB_PREFIX.'socpeople', MAIN_DB_PREFIX.'socpeople_extrafields');
            $objname        = 'Contact';
            $customtabelem  = array('element' => 'contact', 'maintabl' => 'socpeople');
            $complete_label = '';
            $sql_join       = 'LEFT JOIN '.MAIN_DB_PREFIX.'socpeople_extrafields ON ('.MAIN_DB_PREFIX.'socpeople.rowid = '.MAIN_DB_PREFIX.'socpeople_extrafields.fk_object)';
            $sql_where_sp   = true;
            $id_field       = MAIN_DB_PREFIX.'socpeople.rowid';
            break;
        case 'project':
            $tables         = array(MAIN_DB_PREFIX.'projet', MAIN_DB_PREFIX.'projet_extrafields', MAIN_DB_PREFIX.'socpeople');
            $objname        = 'Project';
            $customtabelem  = array('element' => 'project', 'maintabl' => 'projet');
            $complete_label = 'title';
            $sql_join       = 'LEFT JOIN '.MAIN_DB_PREFIX.'projet_extrafields ON ('.MAIN_DB_PREFIX.'projet.rowid = '.MAIN_DB_PREFIX.'projet_extrafields.fk_object)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'c_type_contact ON ('.MAIN_DB_PREFIX.'c_type_contact.element = "project")';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'element_contact ON ('.MAIN_DB_PREFIX.'projet.rowid = '.MAIN_DB_PREFIX.'element_contact.element_id AND '.MAIN_DB_PREFIX.'c_type_contact.rowid = '.MAIN_DB_PREFIX.'element_contact.fk_c_type_contact)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'socpeople ON ('.MAIN_DB_PREFIX.'element_contact.fk_socpeople = '.MAIN_DB_PREFIX.'socpeople.rowid)';
            $sql_where_sp   = true;
            $id_field       = MAIN_DB_PREFIX.'projet.rowid';
            break;
        case 'task':
            $tables         = array(MAIN_DB_PREFIX.'projet_task', MAIN_DB_PREFIX.'projet_task_extrafields', MAIN_DB_PREFIX.'socpeople');
            $objname        = 'Task';
            $complete_label = 'label';
            $sql_join       = 'LEFT JOIN '.MAIN_DB_PREFIX.'projet_task_extrafields ON ('.MAIN_DB_PREFIX.'projet_task.rowid = '.MAIN_DB_PREFIX.'projet_task_extrafields.fk_object)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'c_type_contact ON ('.MAIN_DB_PREFIX.'c_type_contact.element = "project_task")';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'element_contact ON ('.MAIN_DB_PREFIX.'projet_task.rowid = '.MAIN_DB_PREFIX.'element_contact.element_id AND '.MAIN_DB_PREFIX.'c_type_contact.rowid = '.MAIN_DB_PREFIX.'element_contact.fk_c_type_contact)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'socpeople ON ('.MAIN_DB_PREFIX.'element_contact.fk_socpeople = '.MAIN_DB_PREFIX.'socpeople.rowid)';
            $sql_where_sp   = true;
            $id_field       = MAIN_DB_PREFIX.'projet_task.rowid';
            break;
        case 'agenda':
            $tables         = array(MAIN_DB_PREFIX.'actioncomm', MAIN_DB_PREFIX.'actioncomm_extrafields', MAIN_DB_PREFIX.'socpeople');
            $objname        = 'ActionComm';
            $complete_label = '';
            $sql_join       = 'LEFT JOIN '.MAIN_DB_PREFIX.'actioncomm_extrafields ON ('.MAIN_DB_PREFIX.'actioncomm.id = '.MAIN_DB_PREFIX.'actioncomm_extrafields.fk_object)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'socpeople ON ('.MAIN_DB_PREFIX.'actioncomm.fk_contact = '.MAIN_DB_PREFIX.'socpeople.rowid)';
            $sql_where_sp   = true;
            $id_field       = MAIN_DB_PREFIX.'actioncomm.id';
            break;
        case 'propal':
            $tables         = array(MAIN_DB_PREFIX.'propal', MAIN_DB_PREFIX.'propal_extrafields', MAIN_DB_PREFIX.'propaldet',
                MAIN_DB_PREFIX.'propaldet_extrafields', MAIN_DB_PREFIX.'product', MAIN_DB_PREFIX.'socpeople');
            $objname        = 'Propal';
            $customtabelem  = array('element' => 'propal', 'maintabl' => 'propal');
            $complete_label = 'ref_client';
            $sql_join       = 'LEFT JOIN '.MAIN_DB_PREFIX.'propal_extrafields ON ('.MAIN_DB_PREFIX.'propal.rowid = '.MAIN_DB_PREFIX.'propal_extrafields.fk_object)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'propaldet ON ('.MAIN_DB_PREFIX.'propal.rowid = '.MAIN_DB_PREFIX.'propaldet.fk_propal)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'propaldet_extrafields ON ('.MAIN_DB_PREFIX.'propaldet.rowid = '.MAIN_DB_PREFIX.'propaldet_extrafields.fk_object)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'product ON ('.MAIN_DB_PREFIX.'propaldet.fk_product = '.MAIN_DB_PREFIX.'product.rowid)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'c_type_contact ON ('.MAIN_DB_PREFIX.'c_type_contact.element = "propal")';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'element_contact ON ('.MAIN_DB_PREFIX.'propal.rowid = '.MAIN_DB_PREFIX.'element_contact.element_id AND '.MAIN_DB_PREFIX.'c_type_contact.rowid = '.MAIN_DB_PREFIX.'element_contact.fk_c_type_contact)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'socpeople ON ('.MAIN_DB_PREFIX.'element_contact.fk_socpeople = '.MAIN_DB_PREFIX.'socpeople.rowid)';
            $sql_where_p    = true;
            $sql_where_sp   = true;
            $id_field       = MAIN_DB_PREFIX.'propal.rowid';
            break;
        case 'order':
            $tables         = array(MAIN_DB_PREFIX.'commande', MAIN_DB_PREFIX.'commande_extrafields', MAIN_DB_PREFIX.'commandedet',
                MAIN_DB_PREFIX.'commandedet_extrafields', MAIN_DB_PREFIX.'product', MAIN_DB_PREFIX.'socpeople');
            $objname        = 'Commande';
            $customtabelem  = array('element' => 'commande', 'maintabl' => 'commande');
            $complete_label = 'ref_client';
            $sql_join       = 'LEFT JOIN '.MAIN_DB_PREFIX.'commande_extrafields ON ('.MAIN_DB_PREFIX.'commande.rowid = '.MAIN_DB_PREFIX.'commande_extrafields.fk_object)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'commandedet ON ('.MAIN_DB_PREFIX.'commande.rowid = '.MAIN_DB_PREFIX.'commandedet.fk_commande)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'commandedet_extrafields ON ('.MAIN_DB_PREFIX.'commandedet.rowid = '.MAIN_DB_PREFIX.'commandedet_extrafields.fk_object)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'product ON ('.MAIN_DB_PREFIX.'commandedet.fk_product = '.MAIN_DB_PREFIX.'product.rowid)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'c_type_contact ON ('.MAIN_DB_PREFIX.'c_type_contact.element = "commande")';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'element_contact ON ('.MAIN_DB_PREFIX.'commande.rowid = '.MAIN_DB_PREFIX.'element_contact.element_id AND '.MAIN_DB_PREFIX.'c_type_contact.rowid = '.MAIN_DB_PREFIX.'element_contact.fk_c_type_contact)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'socpeople ON ('.MAIN_DB_PREFIX.'element_contact.fk_socpeople = '.MAIN_DB_PREFIX.'socpeople.rowid)';
            $sql_where_p    = true;
            $sql_where_sp   = true;
            $id_field       = MAIN_DB_PREFIX.'commande.rowid';
            break;
        case 'facture':
            $tables         = array(MAIN_DB_PREFIX.'facture', MAIN_DB_PREFIX.'facture_extrafields', MAIN_DB_PREFIX.'facturedet',
                MAIN_DB_PREFIX.'facturedet_extrafields', MAIN_DB_PREFIX.'product', MAIN_DB_PREFIX.'socpeople');
            $objname        = 'Facture';
            $customtabelem  = array('element' => 'invoice', 'maintabl' => 'facture');
            $complete_label = 'ref_client';
            $sql_join       = 'LEFT JOIN '.MAIN_DB_PREFIX.'facture_extrafields ON ('.MAIN_DB_PREFIX.'facture.rowid = '.MAIN_DB_PREFIX.'facture_extrafields.fk_object)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'facturedet ON ('.MAIN_DB_PREFIX.'facture.rowid = '.MAIN_DB_PREFIX.'facturedet.fk_facture)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'facturedet_extrafields ON ('.MAIN_DB_PREFIX.'facturedet.rowid = '.MAIN_DB_PREFIX.'facturedet_extrafields.fk_object)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'product ON ('.MAIN_DB_PREFIX.'facturedet.fk_product = '.MAIN_DB_PREFIX.'product.rowid)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'c_type_contact ON ('.MAIN_DB_PREFIX.'c_type_contact.element = "facture")';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'element_contact ON ('.MAIN_DB_PREFIX.'facture.rowid = '.MAIN_DB_PREFIX.'element_contact.element_id AND '.MAIN_DB_PREFIX.'c_type_contact.rowid = '.MAIN_DB_PREFIX.'element_contact.fk_c_type_contact)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'socpeople ON ('.MAIN_DB_PREFIX.'element_contact.fk_socpeople = '.MAIN_DB_PREFIX.'socpeople.rowid)';
            $sql_where_p    = true;
            $sql_where_sp   = true;
            $id_field       = MAIN_DB_PREFIX.'facture.rowid';
            break;
        case 'contrat':
            $tables         = array(MAIN_DB_PREFIX.'contrat', MAIN_DB_PREFIX.'contrat_extrafields', MAIN_DB_PREFIX.'contratdet',
                MAIN_DB_PREFIX.'contratdet_extrafields', MAIN_DB_PREFIX.'product', MAIN_DB_PREFIX.'socpeople');
            $objname        = 'Contrat';
            $customtabelem  = array('element' => 'contract', 'maintabl' => 'contrat');
            $complete_label = 'ref_customer';
            $sql_join       = 'LEFT JOIN '.MAIN_DB_PREFIX.'contrat_extrafields ON ('.MAIN_DB_PREFIX.'contrat.rowid = '.MAIN_DB_PREFIX.'contrat_extrafields.fk_object)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'contratdet ON ('.MAIN_DB_PREFIX.'contrat.rowid = '.MAIN_DB_PREFIX.'contratdet.fk_contrat)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'contratdet_extrafields ON ('.MAIN_DB_PREFIX.'contratdet.rowid = '.MAIN_DB_PREFIX.'contratdet_extrafields.fk_object)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'product ON ('.MAIN_DB_PREFIX.'contratdet.fk_product = '.MAIN_DB_PREFIX.'product.rowid)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'c_type_contact ON ('.MAIN_DB_PREFIX.'c_type_contact.element = "contrat")';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'element_contact ON ('.MAIN_DB_PREFIX.'contrat.rowid = '.MAIN_DB_PREFIX.'element_contact.element_id AND '.MAIN_DB_PREFIX.'c_type_contact.rowid = '.MAIN_DB_PREFIX.'element_contact.fk_c_type_contact)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'socpeople ON ('.MAIN_DB_PREFIX.'element_contact.fk_socpeople = '.MAIN_DB_PREFIX.'socpeople.rowid)';
            $sql_where_p    = true;
            $sql_where_sp   = true;
            $id_field       = MAIN_DB_PREFIX.'contrat.rowid';
            break;
        case 'ficheinter':
            $tables         = array(MAIN_DB_PREFIX.'fichinter', MAIN_DB_PREFIX.'fichinter_extrafields', MAIN_DB_PREFIX.'fichinterdet',
                MAIN_DB_PREFIX.'fichinterdet_extrafields', MAIN_DB_PREFIX.'product', MAIN_DB_PREFIX.'socpeople');
            $objname        = 'Fichinter';
            $customtabelem  = array('element' => 'intervention', 'maintabl' => 'fichinter');
            $complete_label = 'description';
            $sql_join       = 'LEFT JOIN '.MAIN_DB_PREFIX.'fichinter_extrafields ON ('.MAIN_DB_PREFIX.'fichinter.rowid = '.MAIN_DB_PREFIX.'fichinter_extrafields.fk_object)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'fichinterdet ON ('.MAIN_DB_PREFIX.'fichinter.rowid = '.MAIN_DB_PREFIX.'fichinterdet.fk_fichinter)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'fichinterdet_extrafields ON ('.MAIN_DB_PREFIX.'fichinterdet.rowid = '.MAIN_DB_PREFIX.'fichinterdet_extrafields.fk_object)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'product ON ('.MAIN_DB_PREFIX.'fichinterdet.fk_product = '.MAIN_DB_PREFIX.'product.rowid)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'c_type_contact ON ('.MAIN_DB_PREFIX.'c_type_contact.element = "fichinter")';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'element_contact ON ('.MAIN_DB_PREFIX.'fichinter.rowid = '.MAIN_DB_PREFIX.'element_contact.element_id AND '.MAIN_DB_PREFIX.'c_type_contact.rowid = '.MAIN_DB_PREFIX.'element_contact.fk_c_type_contact)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'socpeople ON ('.MAIN_DB_PREFIX.'element_contact.fk_socpeople = '.MAIN_DB_PREFIX.'socpeople.rowid)';
            $sql_where_p    = true;
            $sql_where_sp   = true;
            $id_field       = MAIN_DB_PREFIX.'fichinter.rowid';
            break;
        case 'shipping':
            $tables         = array(MAIN_DB_PREFIX.'expedition', MAIN_DB_PREFIX.'expedition_extrafields', MAIN_DB_PREFIX.'expeditiondet',
                MAIN_DB_PREFIX.'expeditiondet_extrafields', MAIN_DB_PREFIX.'product', MAIN_DB_PREFIX.'socpeople');
            $objname        = 'Expedition';
            $customtabelem  = array('element' => 'delivery', 'maintabl' => 'expedition');
            $complete_label = 'ref_customer';
            $sql_join       = 'LEFT JOIN '.MAIN_DB_PREFIX.'expedition_extrafields ON ('.MAIN_DB_PREFIX.'expedition.rowid = '.MAIN_DB_PREFIX.'expedition_extrafields.fk_object)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'expeditiondet ON ('.MAIN_DB_PREFIX.'expedition.rowid = '.MAIN_DB_PREFIX.'expeditiondet.fk_expedition)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'expeditiondet_extrafields ON ('.MAIN_DB_PREFIX.'expeditiondet.rowid = '.MAIN_DB_PREFIX.'expeditiondet_extrafields.fk_object)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'commandedet ON ('.MAIN_DB_PREFIX.'expeditiondet.fk_origin_line = '.MAIN_DB_PREFIX.'commandedet.rowid)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'product ON ('.MAIN_DB_PREFIX.'commandedet.fk_product = '.MAIN_DB_PREFIX.'product.rowid)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'c_type_contact ON ('.MAIN_DB_PREFIX.'c_type_contact.element = "expedition")';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'element_contact ON ('.MAIN_DB_PREFIX.'expedition.rowid = '.MAIN_DB_PREFIX.'element_contact.element_id AND '.MAIN_DB_PREFIX.'c_type_contact.rowid = '.MAIN_DB_PREFIX.'element_contact.fk_c_type_contact)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'socpeople ON ('.MAIN_DB_PREFIX.'element_contact.fk_socpeople = '.MAIN_DB_PREFIX.'socpeople.rowid)';
            $sql_where_p    = true;
            $sql_where_sp   = true;
            $id_field       = MAIN_DB_PREFIX.'expedition.rowid';
            break;
        case 'proposal_supplier':
            $tables         = array(MAIN_DB_PREFIX.'supplier_proposal', MAIN_DB_PREFIX.'supplier_proposal_extrafields', MAIN_DB_PREFIX.'supplier_proposaldet',
                MAIN_DB_PREFIX.'supplier_proposaldet_extrafields', MAIN_DB_PREFIX.'product', MAIN_DB_PREFIX.'socpeople');
            $objname        = 'SupplierProposal';
            $complete_label = '';
            $sql_join       = 'LEFT JOIN '.MAIN_DB_PREFIX.'supplier_proposal_extrafields ON ('.MAIN_DB_PREFIX.'supplier_proposal.rowid = '.MAIN_DB_PREFIX.'supplier_proposal_extrafields.fk_object)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'supplier_proposaldet ON ('.MAIN_DB_PREFIX.'supplier_proposal.rowid = '.MAIN_DB_PREFIX.'supplier_proposaldet.fk_supplier_proposal)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'supplier_proposaldet_extrafields ON ('.MAIN_DB_PREFIX.'supplier_proposaldet.rowid = '.MAIN_DB_PREFIX.'supplier_proposaldet_extrafields.fk_object)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'product ON ('.MAIN_DB_PREFIX.'supplier_proposaldet.fk_product = '.MAIN_DB_PREFIX.'product.rowid)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'c_type_contact ON ('.MAIN_DB_PREFIX.'c_type_contact.element = "supplier_proposal")';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'element_contact ON ('.MAIN_DB_PREFIX.'supplier_proposal.rowid = '.MAIN_DB_PREFIX.'element_contact.element_id AND '.MAIN_DB_PREFIX.'c_type_contact.rowid = '.MAIN_DB_PREFIX.'element_contact.fk_c_type_contact)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'socpeople ON ('.MAIN_DB_PREFIX.'element_contact.fk_socpeople = '.MAIN_DB_PREFIX.'socpeople.rowid)';
            $sql_where_p    = true;
            $sql_where_sp   = true;
            $id_field       = MAIN_DB_PREFIX.'supplier_proposal.rowid';
            break;
        case 'order_supplier':
            $tables         = array(MAIN_DB_PREFIX.'commande_fournisseur', MAIN_DB_PREFIX.'commande_fournisseur_extrafields',
                MAIN_DB_PREFIX.'commande_fournisseurdet', MAIN_DB_PREFIX.'commande_fournisseurdet_extrafields', MAIN_DB_PREFIX.'product',
                MAIN_DB_PREFIX.'socpeople');
            $objname        = 'CommandeFournisseur';
            $customtabelem  = array('element' => 'supplier_order', 'maintabl' => 'commande_fournisseur');
            $complete_label = 'ref_supplier';
            $sql_join       = 'LEFT JOIN '.MAIN_DB_PREFIX.'commande_fournisseur_extrafields ON ('.MAIN_DB_PREFIX.'commande_fournisseur.rowid = '.MAIN_DB_PREFIX.'commande_fournisseur_extrafields.fk_object)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'commande_fournisseurdet ON ('.MAIN_DB_PREFIX.'commande_fournisseur.rowid = '.MAIN_DB_PREFIX.'commande_fournisseurdet.fk_commande)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'commande_fournisseurdet_extrafields ON ('.MAIN_DB_PREFIX.'commande_fournisseurdet.rowid = '.MAIN_DB_PREFIX.'commande_fournisseurdet_extrafields.fk_object)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'product ON ('.MAIN_DB_PREFIX.'commande_fournisseurdet.fk_product = '.MAIN_DB_PREFIX.'product.rowid)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'c_type_contact ON ('.MAIN_DB_PREFIX.'c_type_contact.element = "order_supplier")';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'element_contact ON ('.MAIN_DB_PREFIX.'commande_fournisseur.rowid = '.MAIN_DB_PREFIX.'element_contact.element_id AND '.MAIN_DB_PREFIX.'c_type_contact.rowid = '.MAIN_DB_PREFIX.'element_contact.fk_c_type_contact)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'socpeople ON ('.MAIN_DB_PREFIX.'element_contact.fk_socpeople = '.MAIN_DB_PREFIX.'socpeople.rowid)';
            $sql_where_p    = true;
            $sql_where_sp   = true;
            $id_field       = MAIN_DB_PREFIX.'commande_fournisseur.rowid';
            break;
        case 'invoice_supplier':
            $tables         = array(MAIN_DB_PREFIX.'facture_fourn', MAIN_DB_PREFIX.'facture_fourn_extrafields', MAIN_DB_PREFIX.'facture_fourn_det',
                MAIN_DB_PREFIX.'facture_fourn_det_extrafields', MAIN_DB_PREFIX.'product', MAIN_DB_PREFIX.'socpeople');
            $objname        = 'FactureFournisseur';
            $customtabelem  = array('element' => 'supplier_invoice', 'maintabl' => 'facture_fourn');
            $complete_label = 'ref_supplier';
            $sql_join       = 'LEFT JOIN '.MAIN_DB_PREFIX.'facture_fourn_extrafields ON ('.MAIN_DB_PREFIX.'facture_fourn.rowid = '.MAIN_DB_PREFIX.'facture_fourn_extrafields.fk_object)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'facture_fourn_det ON ('.MAIN_DB_PREFIX.'facture_fourn.rowid = '.MAIN_DB_PREFIX.'facture_fourn_det.fk_facture_fourn)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'facture_fourn_det_extrafields ON ('.MAIN_DB_PREFIX.'facture_fourn_det.rowid = '.MAIN_DB_PREFIX.'facture_fourn_det_extrafields.fk_object)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'product ON ('.MAIN_DB_PREFIX.'facture_fourn_det.fk_product = '.MAIN_DB_PREFIX.'product.rowid)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'c_type_contact ON ('.MAIN_DB_PREFIX.'c_type_contact.element = "invoice_supplier")';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'element_contact ON ('.MAIN_DB_PREFIX.'facture_fourn.rowid = '.MAIN_DB_PREFIX.'element_contact.element_id AND '.MAIN_DB_PREFIX.'c_type_contact.rowid = '.MAIN_DB_PREFIX.'element_contact.fk_c_type_contact)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'socpeople ON ('.MAIN_DB_PREFIX.'element_contact.fk_socpeople = '.MAIN_DB_PREFIX.'socpeople.rowid)';
            $sql_where_p    = true;
            $sql_where_sp   = true;
            $id_field       = MAIN_DB_PREFIX.'facture_fourn.rowid';
            break;
        case 'equipement':
            $tables         = array(MAIN_DB_PREFIX.'equipement', MAIN_DB_PREFIX.'equipement_extrafields', MAIN_DB_PREFIX.'equipementevt',
                MAIN_DB_PREFIX.'equipementevt_extrafields', MAIN_DB_PREFIX.'product', MAIN_DB_PREFIX.'socpeople');
            $objname        = 'Equipement';
            $customtabelem  = array('element' => 'equipement', 'maintabl' => 'equipement');
            $complete_label = '';
            $sql_join       = 'LEFT JOIN '.MAIN_DB_PREFIX.'equipement_extrafields ON ('.MAIN_DB_PREFIX.'equipement.rowid = '.MAIN_DB_PREFIX.'equipement_extrafields.fk_object)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'equipementevt ON ('.MAIN_DB_PREFIX.'equipement.rowid = '.MAIN_DB_PREFIX.'equipementevt.fk_equipement)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'equipementevt_extrafields ON ('.MAIN_DB_PREFIX.'equipementevt.rowid = '.MAIN_DB_PREFIX.'equipementevt_extrafields.fk_object)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'product ON ('.MAIN_DB_PREFIX.'equipement.fk_product = '.MAIN_DB_PREFIX.'product.rowid)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'c_type_contact ON ('.MAIN_DB_PREFIX.'c_type_contact.element = "equipement")';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'element_contact ON ('.MAIN_DB_PREFIX.'equipement.rowid = '.MAIN_DB_PREFIX.'element_contact.element_id AND '.MAIN_DB_PREFIX.'c_type_contact.rowid = '.MAIN_DB_PREFIX.'element_contact.fk_c_type_contact)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'socpeople ON ('.MAIN_DB_PREFIX.'element_contact.fk_socpeople = '.MAIN_DB_PREFIX.'socpeople.rowid)';
            $sql_where_p    = true;
            $sql_where_sp   = true;
            $id_field       = MAIN_DB_PREFIX.'equipement.rowid';
            break;
        case 'ndfp':
            $tables         = array(MAIN_DB_PREFIX.'ndfp', MAIN_DB_PREFIX.'ndfp_det');
            $objname        = 'Ndfp';
            $complete_label = 'description';
            $sql_join       = 'LEFT JOIN '.MAIN_DB_PREFIX.'ndfp_det ON ('.MAIN_DB_PREFIX.'ndfp.rowid = '.MAIN_DB_PREFIX.'ndfp_det.fk_ndfp)';
            $id_field       = MAIN_DB_PREFIX.'ndfp.rowid';
            break;
        case 'contacttracking':
            $tables         = array(MAIN_DB_PREFIX.'contacttracking');
            $objname        = 'Contacttracking';
            $complete_label = 'comment';
            $sql_join       = 'LEFT JOIN '.MAIN_DB_PREFIX.'socpeople ON ('.MAIN_DB_PREFIX.'contacttracking.fk_contact = '.MAIN_DB_PREFIX.'socpeople.rowid)';
            $sql_where_sp   = true;
            $id_field       = MAIN_DB_PREFIX.'contacttracking.rowid';
            break;
        case 'domain':
            $tables         = array(MAIN_DB_PREFIX.'domain', MAIN_DB_PREFIX.'domain_extrafields');
            $objname        = 'Domain';
            $complete_label = 'label';
            $sql_join       = 'LEFT JOIN '.MAIN_DB_PREFIX.'domain_extrafields ON ('.MAIN_DB_PREFIX.'domain.rowid = '.MAIN_DB_PREFIX.'domain_extrafields.fk_object)';
            $id_field       = MAIN_DB_PREFIX.'domain.rowid';
            break;
        case 'hosting':
            $tables         = array(MAIN_DB_PREFIX.'host', MAIN_DB_PREFIX.'host_extrafields');
            $objname        = 'Host';
            $complete_label = 'label';
            $sql_join       = 'LEFT JOIN '.MAIN_DB_PREFIX.'host_extrafields ON ('.MAIN_DB_PREFIX.'host.rowid = '.MAIN_DB_PREFIX.'host_extrafields.fk_object)';
            $id_field       = MAIN_DB_PREFIX.'host.rowid';
            break;
        case 'ticket':
            $tables         = array(MAIN_DB_PREFIX.'ticket', MAIN_DB_PREFIX.'ticket_extrafields', MAIN_DB_PREFIX.'socpeople');
            $objname        = 'Ticket';
            $complete_label = 'subject';
            $sql_join       = 'LEFT JOIN '.MAIN_DB_PREFIX.'ticket_extrafields ON ('.MAIN_DB_PREFIX.'ticket.rowid = '.MAIN_DB_PREFIX.'ticket_extrafields.fk_object)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'c_type_contact ON ('.MAIN_DB_PREFIX.'c_type_contact.element = "ticket")';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'element_contact ON ('.MAIN_DB_PREFIX.'ticket.rowid = '.MAIN_DB_PREFIX.'element_contact.element_id AND '.MAIN_DB_PREFIX.'c_type_contact.rowid = '.MAIN_DB_PREFIX.'element_contact.fk_c_type_contact)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'socpeople ON ('.MAIN_DB_PREFIX.'element_contact.fk_socpeople = '.MAIN_DB_PREFIX.'socpeople.rowid)';
            $sql_where_sp   = true;
            $id_field       = MAIN_DB_PREFIX.'ticket.rowid';
            break;
        case 'ticketsup':
            $tables         = array(MAIN_DB_PREFIX.'ticketsup', MAIN_DB_PREFIX.'ticketsup_extrafields', MAIN_DB_PREFIX.'ticketsup_logs',
                MAIN_DB_PREFIX.'ticketsup_msg', MAIN_DB_PREFIX.'socpeople');
            $objname        = 'Ticketsup';
            $complete_label = 'subject';
            $sql_join       = 'LEFT JOIN '.MAIN_DB_PREFIX.'ticketsup_extrafields ON ('.MAIN_DB_PREFIX.'ticketsup.rowid = '.MAIN_DB_PREFIX.'ticketsup_extrafields.fk_object)';
            $sql_join       .= 'LEFT JOIN '.MAIN_DB_PREFIX.'ticketsup_logs ON ('.MAIN_DB_PREFIX.'ticketsup.track_id = '.MAIN_DB_PREFIX.'ticketsup_logs.fk_track_id)';
            $sql_join       .= 'LEFT JOIN '.MAIN_DB_PREFIX.'ticketsup_msg ON ('.MAIN_DB_PREFIX.'ticketsup.track_id = '.MAIN_DB_PREFIX.'ticketsup_msg.fk_track_id)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'c_type_contact ON ('.MAIN_DB_PREFIX.'c_type_contact.element = "ticketsup")';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'element_contact ON ('.MAIN_DB_PREFIX.'ticketsup.rowid = '.MAIN_DB_PREFIX.'element_contact.element_id AND '.MAIN_DB_PREFIX.'c_type_contact.rowid = '.MAIN_DB_PREFIX.'element_contact.fk_c_type_contact)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'socpeople ON ('.MAIN_DB_PREFIX.'element_contact.fk_socpeople = '.MAIN_DB_PREFIX.'socpeople.rowid)';
            $sql_where_sp   = true;
            $id_field       = MAIN_DB_PREFIX.'ticketsup.rowid';
            break;
        case 'propalehistory':
            $tables         = array(MAIN_DB_PREFIX.'propal', MAIN_DB_PREFIX.'propal_extrafields', MAIN_DB_PREFIX.'propaldet',
                MAIN_DB_PREFIX.'propaldet_extrafields', MAIN_DB_PREFIX.'propale_history');
            $objname        = 'PropalHist';
            $complete_label = 'ref_client';
            $sql_join       = 'LEFT JOIN '.MAIN_DB_PREFIX.'propal_extrafields ON ('.MAIN_DB_PREFIX.'propal.rowid = '.MAIN_DB_PREFIX.'propal_extrafields.fk_object)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'propaldet ON ('.MAIN_DB_PREFIX.'propal.rowid = '.MAIN_DB_PREFIX.'propaldet.fk_propal)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'propaldet_extrafields ON ('.MAIN_DB_PREFIX.'propaldet.rowid = '.MAIN_DB_PREFIX.'propaldet_extrafields.fk_object)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'propale_history ON ('.MAIN_DB_PREFIX.'propal.rowid = '.MAIN_DB_PREFIX.'propale_history.fk_propale)';
            $id_field       = MAIN_DB_PREFIX.'propal.rowid';
            break;
        case 'rmindr':
            $tables         = array(MAIN_DB_PREFIX.'rmindr');
            $objname        = 'rmindr';
            $complete_label = 'description';
            $sql_join       = '';
            $id_field       = MAIN_DB_PREFIX.'rmindr.rowid';
            break;
        case 'factory':
            $tables         = array(MAIN_DB_PREFIX.'factory', MAIN_DB_PREFIX.'factory_extrafields', MAIN_DB_PREFIX.'factorydet');
            $objname        = 'Factory';
            $complete_label = 'description';
            $sql_join       = 'LEFT JOIN '.MAIN_DB_PREFIX.'factory_extrafields ON ('.MAIN_DB_PREFIX.'factory.rowid = '.MAIN_DB_PREFIX.'factory_extrafields.fk_object)';
            $sql_join       .= 'LEFT JOIN '.MAIN_DB_PREFIX.'factorydet ON ('.MAIN_DB_PREFIX.'factory.rowid = '.MAIN_DB_PREFIX.'factorydet.fk_factory)';
            $id_field       = MAIN_DB_PREFIX.'factory.rowid';
            break;
		case 'qualityreport':
            $tables         = array(MAIN_DB_PREFIX.'qualityreport', MAIN_DB_PREFIX.'qualityreport_extrafields', MAIN_DB_PREFIX.'socpeople');
            $objname        = 'QualityReport';
            $customtabelem  = array('element' => 'qualityreport', 'maintabl' => 'qualityreport');
            $complete_label = 'title';
            $sql_join       = 'LEFT JOIN '.MAIN_DB_PREFIX.'qualityreport_extrafields ON ('.MAIN_DB_PREFIX.'qualityreport.rowid = '.MAIN_DB_PREFIX.'qualityreport_extrafields.fk_object)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'c_type_contact ON ('.MAIN_DB_PREFIX.'c_type_contact.element = "qualityreport")';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'element_contact ON ('.MAIN_DB_PREFIX.'qualityreport.rowid = '.MAIN_DB_PREFIX.'element_contact.element_id AND '.MAIN_DB_PREFIX.'c_type_contact.rowid = '.MAIN_DB_PREFIX.'element_contact.fk_c_type_contact)';
            $sql_join       .= ' LEFT JOIN '.MAIN_DB_PREFIX.'socpeople ON ('.MAIN_DB_PREFIX.'element_contact.fk_socpeople = '.MAIN_DB_PREFIX.'socpeople.rowid)';
            $sql_where_sp   = true;
            $id_field       = MAIN_DB_PREFIX.'qualityreport.rowid';
            break;

    } // switch ($TObjectTypeValid)
    $sql_where  = ' 0 ';
    $sql_fields = '';
    if ($conf->global->MAIN_MODULE_CUSTOMTABS && is_array($customtabelem)) {
        $restab = $db->query('SELECT DISTINCT '.MAIN_DB_PREFIX.'customtabs.tablename FROM '.MAIN_DB_PREFIX.'customtabs WHERE '.MAIN_DB_PREFIX.'customtabs.element LIKE "'.$customtabelem['element'].'"');
        while ($tab    = $db->fetch_object($restab)) {
            $tables[] = MAIN_DB_PREFIX.'cust_'.$tab->tablename.'_extrafields';
            $sql_join .= ' LEFT JOIN '.MAIN_DB_PREFIX.'cust_'.$tab->tablename.'_extrafields ON ('.MAIN_DB_PREFIX.$customtabelem['maintabl'].'.rowid = '.MAIN_DB_PREFIX.'cust_'.$tab->tablename.'_extrafields.fk_object)';
        } // while($tab = $db->fetch_object($restab))
    } // if ($conf->global->MAIN_MODULE_CUSTOMTABS && is_array($customtabelem))
    foreach ($tables as $table) {
        $res = $db->query('DESCRIBE '.$table);
        if ($res)
                while ($tbl = $db->fetch_object($res)) {
                $fieldname  = $tbl->Field;
                $sql_fields .= ','.$table.'.'.$fieldname.' as '.$table.'_'.$fieldname;
                if (strpos($tbl->Type, 'varchar') !== false || strpos($tbl->Type, 'text') !== false)
                        $sql_where  .= ' OR '.$table.'.'.$fieldname.' LIKE "%'.$db->escape($keyword).'%"';
                else if (strpos($tbl->Type, 'int') !== false || strpos($tbl->Type, 'double') !== false || strpos($tbl->Type,
                        'float') !== false) {
                    $i_keyword = (double) $keyword;
                    if (!empty($i_keyword)) $sql_where .= ' OR '.$table.'.'.$fieldname.' = '.$i_keyword;
                } // else if ( strpos($tbl->Type,'int') !== false || strpos($tbl->Type,'double')!== false || strpos($tbl->Type,'float') !== false )
                else if (strpos($tbl->Type, 'date') !== false || strpos($tbl->Type, 'time') !== false)
                        $sql_where .= ' OR '.$table.'.'.$fieldname.' LIKE "'.$db->escape($keyword).'%"';
                else $sql_where .= ' OR '.$table.'.'.$fieldname.' = "'.$db->escape($keyword).'"';
            } // while($tbl = $db->fetch_object($res))
    } // foreach($tables as $table)
    $sql_where  .= $sql_where_p ? ' OR '.MAIN_DB_PREFIX.'product.ref LIKE "%'.$db->escape($keyword).'%"' : '';
    $sql_where  .= $sql_where_sp ? ' OR CONCAT_WS(" ",'.MAIN_DB_PREFIX.'socpeople.firstname, '.MAIN_DB_PREFIX.'socpeople.lastname) LIKE "%'.$db->escape($keyword).'%" OR CONCAT_WS(" ",'.MAIN_DB_PREFIX.'socpeople.lastname, '.MAIN_DB_PREFIX.'socpeople.firstname) LIKE "%'.$db->escape($keyword).'%"'
            : '';
    $sql        = 'SELECT DISTINCT '.$id_field.' as rowid FROM '.$tables[0].' '.$sql_join.' WHERE ('.$sql_where.') ';
    if (is_callable('getEntity') && isset($customtabelem))
        $sql        .= 'AND ' . $tables[0] . '.entity IN (' . getEntity($customtabelem['element']) . ') ';
    else
        $sql        .= 'AND ' . $tables[0] . '.entity = ' . $conf->entity . ' ';
    $sql        .= 'LIMIT '.$nbRows.' ';
//     echo $sql.'<br>';
//     exit;
    $res        = $db->query($sql);
    $nb_results = $db->num_rows($res);
    if (!$asArray)
            print '<table style = "width: 100%; border-spacing: 0px;">
								<tr class = "liste_titre">
									<td colspan = "2" style = "padding: 2px 5px 2px 5px;"><span class = "badge">'.$nb_results.'</span>&nbsp;&nbsp;'.$langs->trans($objname).'</td>
								</tr>';
    if ($nb_results == 0) {
        if (!$asArray) print '<td colspan = "2" style = "padding: 2px 5px 2px 5px;">Pas de résultat</td>';
    } // if ($nb_results == 0)
    else {

        if (class_exists($objname)) {
            while ($obj = $db->fetch_object($res)) {
                $o      = new $objname($db);
                $o->fetch($obj->rowid);
                if ($o->id <= 0) continue;
                $label  = '';
                if ($complete_label) if (empty($label) && !empty($o->$complete_label)) $label  = $o->$complete_label;
                if ($objname == 'Categorie' && method_exists($o, 'getNomUrl'))
                        $label  = trim($o->getNomUrl(2).' '.$o->label.' '.$label);
                if ($objname == 'rmindr') $label  = trim($o->label.' '.$label);
                else if (method_exists($o, 'getNomUrl')) $label  = trim($o->getNomUrl(1).' '.$label);
                if (method_exists($o, 'getLibStatut')) $statut = $o->getLibStatut(3);
                $desc   = '';
                if ($show_find_field) {
                    foreach ($o as $k => $v)
                        if (is_string($v) && preg_match("/".$keyword."/", $v))
                                $desc .= '<br />'.$k.' : '.preg_replace('/'.$keyword.'/',
                                    '<span class = "highlight">'.$keyword.'</span>', $v);
                } // if ($show_find_field)
                preg_match_all('/<a[^>]+href=([\'"])(?<href>.+?)\1[^>]*>/i', $label, $match);
                $url       = is_array($match['href']) ? $match['href'][0] : $match['href'];
                if ($asArray)
                        $TResult[] = array('categorie' => $langs->trans($objname),
                        'object_name' => $objname,
                        'label' => $label,
                        'label_clean' => strip_tags($label),
                        'url' => $url,
                        'desc' => $desc,
                        'statut' => $statut,
                        'id' => $o->id,
                        'type' => $TObjectTypeValid
                    );
                else
                        print '<tr>
                                <td class = "nowrap" style = "padding: 2px 0px 2px 5px;">'.$label.$desc.'</td>
                                <td align = "right" style = "padding: 2px 5px 2px 0px;">'.$statut.'</td>
                            </tr>';
            } // while($obj = $db->fetch_object($res))
        } // if (class_exists($objname))
    } // else	// if ($nb_results == 0)
    if (!$asArray) print '</table>';
    else return $TResult;
}

// function _search($TObjectTypeValid, $keyword, $asArray = false)

function get_dol_module_list()
{
    global $conf;
    $modules = array();
    if (!empty($conf->societe->enabled)) {
        $modules[] = 'thirdparty';
        $modules[] = 'contact';
    }
    if (!empty($conf->projet->enabled)) {
        $modules[] = 'project';
        //$modules[] = 'task';
    }
//    if (!empty($conf->agenda->enabled)) $modules[] = 'agenda';
    if (!empty($conf->propal->enabled)) $modules[] = 'propal';
    if (!empty($conf->ticket->enabled)) $modules[] = 'ticket';
    if (!empty($conf->commande->enabled)) $modules[] = 'order';
    if (!empty($conf->facture->enabled)) $modules[] = 'facture';
    if (!empty($conf->contrat->enabled)) $modules[] = 'contrat';
//    if (!empty($conf->ficheinter->enabled)) $modules[] = 'ficheinter';
    if (!empty($conf->expedition->enabled)) $modules[] = 'shipping';
    if (!empty($conf->supplier_proposal->enabled)) $modules[] = 'proposal_supplier';
    if (!empty($conf->supplier_order->enabled)) $modules[] = 'order_supplier';
    if (!empty($conf->facturefournisseur->enabled)) $modules[] = 'invoice_supplier';
    if (!empty($conf->qualityreport->enabled)) $modules[] = 'qualityreport';
//    if (!empty($conf->categorie->enabled)) $modules[] = 'categorie';
    return $modules;
}
